from Products.Silva.ExtensionRegistry import extensionRegistry
from Products.FileSystemSite.DirectoryView import registerDirectory

import install, util
import Blob, SampleDocument, Agenda

def initialize(context):

   registerDirectory('views', globals())
   registerDirectory('widgets', globals())

   extensionRegistry.register(
   'SilvaSampleContentTypes', 'Sample content types for Silva', 
   context,
   [Blob, SampleDocument, Agenda],
   install, depends_on='Silva')
