## "render_childs"
##bind context=context
##parameters=node, form=None

from Products.SilvaSampleContentTypes.util import DummyFormRequest

form = context.get_form()
    
editor = context.service_editor
form_request = DummyFormRequest(context.get_form_values_from_session(node))
renderings=[]

for child in node.childNodes:
    if child.nodeType != node.ELEMENT_NODE:
        continue
    
    name = child.nodeName
    
    if form.has_field(name):
        field = form.get_field(name)
        renderings.append(context.render_field(node=child, field=field, form_values = form_request))
    else:
        renderings.append(editor.getWidget(child).render())

return '\n'.join(renderings)
        
                          
