## "save_helper"
##bind context=context
##parameters=

request = context.REQUEST
node = request.node
editor = context.service_editor
form = context.get_form()

form_values = context.get_form_values_from_session(node)
request_form = getattr(request, 'form', None)
if request_form is not None:
    form_values.clear()
    form_values.update(request_form)
else:
    raise ValueError,'save_helper called without form values?'

form_error = None
from Products.Formulator.Errors import FormValidationError
try:
    result = form.validate_all(request)
except FormValidationError, e:
    form_error = e
    result = None
    # return context.util.render_form_errors(e)

errors = 0

for child in node.childNodes:
    if child.nodeType != node.ELEMENT_NODE:
        continue
    
    name = child.nodeName
    
    if form.has_field(name):
        if result is None: continue
        field = form.get_field(name)
        err = context.save_field(field=field, node=child, value=result[name])
        err = err or ''
        errors = errors or err
        editor.setMessage(child, err)
    else:
        err = editor.getWidget(child).save_helper()
        err = err or ''
        errors = errors or err
        editor.setMessage(child, err)

if form_error is not None:
    return context.render_form_errors(form_error)
if errors:
    return "Error when saving fields."
        
                          
