## "get_content_for_field"
##bind container=container

request = container.REQUEST
# XXX not request.node, as this does not get the settings from render_field.py
node = request['sub_node']

# the context is the current Formulator field

field_id = context.id
meta_type = context.meta_type

if meta_type=='StringField':
    return node.render_heading_as_editable(node)
elif meta_type=='TextAreaField':
    return node.render_text_as_editable(node)
elif field.meta_type=='DateTimeField':
    from DateTime import DateTime
    if node.hasChildNodes():
        # XXX handle parse errors here ?
        # does not handle fractions of milliseconds, actually ;)
        return DateTime(long(float(node.firstChild.data)))

    # empty node: current date?
    return None
else:
    # other fields: what now?
    raise TypeError, 'fixed_size_top does not support field type '+meta_type+' for name '+field_id
